import { IPublicApiCanvas, IPublicModelDropLocation, IPublicModelScrollTarget, IPublicModelScrollable, IPublicModelScroller, IPublicTypeLocationData, IPublicModelEditor, IPublicModelDragon, IPublicModelActiveTracker } from '@alilc/lowcode-types';
import { editorSymbol, designerSymbol } from '../symbols';
export declare class Canvas implements IPublicApiCanvas {
    private readonly [editorSymbol];
    private get [designerSymbol]();
    constructor(editor: IPublicModelEditor);
    createScrollTarget(shell: HTMLDivElement): IPublicModelScrollTarget;
    createScroller(scrollable: IPublicModelScrollable): IPublicModelScroller;
    /**
     * 创建插入位置，考虑放到 dragon 中
     */
    createLocation(locationData: IPublicTypeLocationData): IPublicModelDropLocation;
    get dragon(): IPublicModelDragon | null;
    get activeTracker(): IPublicModelActiveTracker | null;
    /**
     * @deprecated
     */
    get dropLocation(): IPublicModelDropLocation;
}
