import _extends from "@babel/runtime/helpers/extends";
import _createClass from "@babel/runtime/helpers/createClass";
import { ScrollTarget as InnerScrollTarget } from '@alilc/lowcode-designer';
import { editorSymbol, designerSymbol, nodeSymbol } from '../symbols';
import { Dragon } from '../model';
import { DropLocation } from '../model/drop-location';
import { ActiveTracker } from '../model/active-tracker';
export var Canvas = /*#__PURE__*/function () {
  function Canvas(editor) {
    this[editorSymbol] = void 0;
    this[editorSymbol] = editor;
  }
  var _proto = Canvas.prototype;
  _proto.createScrollTarget = function createScrollTarget(shell) {
    return new InnerScrollTarget(shell);
  };
  _proto.createScroller = function createScroller(scrollable) {
    return this[designerSymbol].createScroller(scrollable);
  }

  /**
   * 创建插入位置，考虑放到 dragon 中
   */;
  _proto.createLocation = function createLocation(locationData) {
    return this[designerSymbol].createLocation(_extends({}, locationData, {
      target: locationData.target[nodeSymbol]
    }));
  };
  _createClass(Canvas, [{
    key: designerSymbol,
    get: function get() {
      return this[editorSymbol].get('designer');
    }
  }, {
    key: "dragon",
    get: function get() {
      return Dragon.create(this[designerSymbol].dragon);
    }
  }, {
    key: "activeTracker",
    get: function get() {
      var activeTracker = new ActiveTracker(this[designerSymbol].activeTracker);
      return activeTracker;
    }

    /**
     * @deprecated
     */
  }, {
    key: "dropLocation",
    get: function get() {
      return DropLocation.create(this[designerSymbol].dropLocation || null);
    }
  }]);
  return Canvas;
}();