import { IPublicTypeCustomView, IPublicApiSetters, IPublicTypeRegisteredSetter } from '@alilc/lowcode-types';
import { Setters as InnerSetters } from '@alilc/lowcode-editor-core';
import { ReactNode } from 'react';
declare const innerSettersSymbol: unique symbol;
declare const settersSymbol: unique symbol;
export declare class Setters implements IPublicApiSetters {
    readonly workspaceMode: boolean;
    readonly [innerSettersSymbol]: InnerSetters;
    get [settersSymbol](): InnerSetters;
    constructor(innerSetters: InnerSetters, workspaceMode?: boolean);
    /**
     * 获取指定 setter
     * @param type
     * @returns
     */
    getSetter: (type: string) => IPublicTypeRegisteredSetter;
    /**
     * 获取已注册的所有 settersMap
     * @returns
     */
    getSettersMap(): Map<string, IPublicTypeRegisteredSetter & {
        type: string;
    }>;
    /**
     * 注册一个 setter
     * @param typeOrMaps
     * @param setter
     * @returns
     */
    registerSetter: (typeOrMaps: string | {
        [key: string]: IPublicTypeRegisteredSetter | IPublicTypeCustomView;
    }, setter?: IPublicTypeCustomView | IPublicTypeRegisteredSetter | undefined) => void;
    createSetterContent: (setter: any, props: Record<string, any>) => ReactNode;
}
export {};
