import _createClass from "@babel/runtime/helpers/createClass";
import { Plugins } from '@alilc/lowcode-shell';
import { Window } from '../model/window';
import { workspaceSymbol } from '../symbols';
export var Workspace = /*#__PURE__*/function () {
  function Workspace(innerWorkspace) {
    this[workspaceSymbol] = void 0;
    this[workspaceSymbol] = innerWorkspace;
  }
  var _proto = Workspace.prototype;
  _proto.registerResourceType = function registerResourceType(resourceName, resourceType, options) {
    this[workspaceSymbol].registerResourceType(resourceName, resourceType, options);
  };
  _proto.openEditorWindow = function openEditorWindow(resourceName, title, viewType) {
    this[workspaceSymbol].openEditorWindow(resourceName, title, viewType);
  };
  _proto.openEditorWindowById = function openEditorWindowById(id) {
    this[workspaceSymbol].openEditorWindowById(id);
  };
  _proto.removeEditorWindow = function removeEditorWindow(resourceName, title) {
    this[workspaceSymbol].removeEditorWindow(resourceName, title);
  };
  _proto.removeEditorWindowById = function removeEditorWindowById(id) {
    this[workspaceSymbol].removeEditorWindowById(id);
  };
  _proto.onChangeWindows = function onChangeWindows(fn) {
    return this[workspaceSymbol].onChangeWindows(fn);
  };
  _proto.onChangeActiveWindow = function onChangeActiveWindow(fn) {
    return this[workspaceSymbol].onChangeActiveWindow(fn);
  };
  _createClass(Workspace, [{
    key: "isActive",
    get: function get() {
      return this[workspaceSymbol].isActive;
    }
  }, {
    key: "window",
    get: function get() {
      return new Window(this[workspaceSymbol].window);
    }
  }, {
    key: "plugins",
    get: function get() {
      return new Plugins(this[workspaceSymbol].plugins, true);
    }
  }, {
    key: "windows",
    get: function get() {
      return this[workspaceSymbol].windows.map(function (d) {
        return new Window(d);
      });
    }
  }]);
  return Workspace;
}();