"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.Canvas = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _lowcodeDesigner = require("@alilc/lowcode-designer");
var _symbols = require("../symbols");
var _model = require("../model");
var _dropLocation = require("../model/drop-location");
var _activeTracker = require("../model/active-tracker");
var Canvas = /*#__PURE__*/function () {
  function Canvas(editor) {
    this[_symbols.editorSymbol] = void 0;
    this[_symbols.editorSymbol] = editor;
  }
  var _proto = Canvas.prototype;
  _proto.createScrollTarget = function createScrollTarget(shell) {
    return new _lowcodeDesigner.ScrollTarget(shell);
  };
  _proto.createScroller = function createScroller(scrollable) {
    return this[_symbols.designerSymbol].createScroller(scrollable);
  }

  /**
   * 创建插入位置，考虑放到 dragon 中
   */;
  _proto.createLocation = function createLocation(locationData) {
    return this[_symbols.designerSymbol].createLocation((0, _extends2["default"])({}, locationData, {
      target: locationData.target[_symbols.nodeSymbol]
    }));
  };
  (0, _createClass2["default"])(Canvas, [{
    key: _symbols.designerSymbol,
    get: function get() {
      return this[_symbols.editorSymbol].get('designer');
    }
  }, {
    key: "dragon",
    get: function get() {
      return _model.Dragon.create(this[_symbols.designerSymbol].dragon);
    }
  }, {
    key: "activeTracker",
    get: function get() {
      var activeTracker = new _activeTracker.ActiveTracker(this[_symbols.designerSymbol].activeTracker);
      return activeTracker;
    }

    /**
     * @deprecated
     */
  }, {
    key: "dropLocation",
    get: function get() {
      return _dropLocation.DropLocation.create(this[_symbols.designerSymbol].dropLocation || null);
    }
  }]);
  return Canvas;
}();
exports.Canvas = Canvas;