"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.Setters = void 0;
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _lowcodeEditorCore = require("@alilc/lowcode-editor-core");
var innerSettersSymbol = Symbol('setters');
var settersSymbol = Symbol('setters');
var Setters = /*#__PURE__*/function () {
  function Setters(innerSetters, workspaceMode) {
    var _this = this;
    if (workspaceMode === void 0) {
      workspaceMode = false;
    }
    this.workspaceMode = workspaceMode;
    this[innerSettersSymbol] = void 0;
    this.getSetter = function (type) {
      return _this[settersSymbol].getSetter(type);
    };
    this.registerSetter = function (typeOrMaps, setter) {
      return _this[settersSymbol].registerSetter(typeOrMaps, setter);
    };
    this.createSetterContent = function (setter, props) {
      return _this[settersSymbol].createSetterContent(setter, props);
    };
    this[innerSettersSymbol] = innerSetters;
  }

  /**
   * 获取指定 setter
   * @param type
   * @returns
   */
  var _proto = Setters.prototype;
  /**
   * 获取已注册的所有 settersMap
   * @returns
   */
  _proto.getSettersMap = function getSettersMap() {
    return this[settersSymbol].getSettersMap();
  }

  /**
   * 注册一个 setter
   * @param typeOrMaps
   * @param setter
   * @returns
   */;
  (0, _createClass2["default"])(Setters, [{
    key: settersSymbol,
    get: function get() {
      if (this.workspaceMode) {
        return this[innerSettersSymbol];
      }
      var workspace = _lowcodeEditorCore.globalContext.get('workspace');
      if (workspace.isActive) {
        return workspace.window.innerSetters;
      }
      return this[innerSettersSymbol];
    }
  }]);
  return Setters;
}();
exports.Setters = Setters;