import { IPublicApiWorkspace } from '@alilc/lowcode-types';
import { Workspace as InnerWorkSpace } from '@alilc/lowcode-workspace';
import { Window } from '../model/window';
import { workspaceSymbol } from '../symbols';
export declare class Workspace implements IPublicApiWorkspace {
    readonly [workspaceSymbol]: InnerWorkSpace;
    constructor(innerWorkspace: InnerWorkSpace);
    get isActive(): boolean;
    get window(): Window;
    registerResourceType(resourceName: string, resourceType: 'editor', options: any): void;
    openEditorWindow(resourceName: string, title: string, viewType?: string): void;
    openEditorWindowById(id: string): void;
    removeEditorWindow(resourceName: string, title: string): void;
    removeEditorWindowById(id: string): void;
    get plugins(): any;
    get windows(): Window[];
    onChangeWindows(fn: () => void): () => void;
    onChangeActiveWindow(fn: () => void): () => void;
}
