"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.Workspace = void 0;
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _lowcodeShell = require("@alilc/lowcode-shell");
var _window = require("../model/window");
var _symbols = require("../symbols");
var Workspace = /*#__PURE__*/function () {
  function Workspace(innerWorkspace) {
    this[_symbols.workspaceSymbol] = void 0;
    this[_symbols.workspaceSymbol] = innerWorkspace;
  }
  var _proto = Workspace.prototype;
  _proto.registerResourceType = function registerResourceType(resourceName, resourceType, options) {
    this[_symbols.workspaceSymbol].registerResourceType(resourceName, resourceType, options);
  };
  _proto.openEditorWindow = function openEditorWindow(resourceName, title, viewType) {
    this[_symbols.workspaceSymbol].openEditorWindow(resourceName, title, viewType);
  };
  _proto.openEditorWindowById = function openEditorWindowById(id) {
    this[_symbols.workspaceSymbol].openEditorWindowById(id);
  };
  _proto.removeEditorWindow = function removeEditorWindow(resourceName, title) {
    this[_symbols.workspaceSymbol].removeEditorWindow(resourceName, title);
  };
  _proto.removeEditorWindowById = function removeEditorWindowById(id) {
    this[_symbols.workspaceSymbol].removeEditorWindowById(id);
  };
  _proto.onChangeWindows = function onChangeWindows(fn) {
    return this[_symbols.workspaceSymbol].onChangeWindows(fn);
  };
  _proto.onChangeActiveWindow = function onChangeActiveWindow(fn) {
    return this[_symbols.workspaceSymbol].onChangeActiveWindow(fn);
  };
  (0, _createClass2["default"])(Workspace, [{
    key: "isActive",
    get: function get() {
      return this[_symbols.workspaceSymbol].isActive;
    }
  }, {
    key: "window",
    get: function get() {
      return new _window.Window(this[_symbols.workspaceSymbol].window);
    }
  }, {
    key: "plugins",
    get: function get() {
      return new _lowcodeShell.Plugins(this[_symbols.workspaceSymbol].plugins, true);
    }
  }, {
    key: "windows",
    get: function get() {
      return this[_symbols.workspaceSymbol].windows.map(function (d) {
        return new _window.Window(d);
      });
    }
  }]);
  return Workspace;
}();
exports.Workspace = Workspace;